//+------------------------------------------------------------------+
//|                                                 LONDON model.mq5 |
//|                        Copyright 2010, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2010, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"

#include <Trade\Trade.mqh>
#include <Trade\PositionInfo.mqh>
#include <Trade\AccountInfo.mqh>
#include <Models\model_ss.mqh>
#include <Optimisation\CustomOptimisation.mqh>
#define DAY 86400 //    
int days_in_month[12] = {31,28,31,30,31,30,31,31,30,31,30,31}; //    

CList *list_model;
CTrade trade;
MqlTick new_tick,old_tick;
TCustomCriterionArray   *criterion_Ptr;
double wdr_summa;         //      
double wdr_value;         //    
ushort wdr_count;         //   
double initial_deposit;   //  
datetime dt_debit;        //      
uint days_delay;
 
//   
input bool     ss_default                 = true;
input string   SOT                        = "System Order Type";//================================
input ENUM_ORDER_TYPE System_Order_Type   = ORDER_TYPE_SELL;
input short    System_Type                = 2;
input string   EnterParameters            = "Enter ";//================================
input  short    enter_y                    = 0;
input  short    enter_ind                  = 0;
input  short    enter_ind_line             = 1;
input  string   EditParameters             = "Edit ";//================================
input  short    edit_y                     = 0;
input  short    edit_ind                   = 0;
input  short    edit_ind_line              = 0;
input  string   ExitParameters             = "Exit ";//================================
input  short    exit_y                     = 3;
input  short    exit_ind                   = 0;
input  short    exit_ind_line              = 0;
input  string   TPSL_Enter                 = "TPSL Enter";//================================
input  short    enter_tpsl_y               = 0;
input  short    enter_tpsl_ind             = 0;
input  short    enter_tp_ind_line          = 4;
input  short    enter_sl_ind_line          = 1;
input  string   TPSL_Edit                  = "TPSL Edit";//================================
input  short    edit_tpsl_y                = 0;
input  short    edit_tpsl_ind              = 0;
input  short    edit_tp_ind_line           = 4;
input  short    edit_sl_ind_line           = 1;

//input ENUM_TIMEFRAMES    Ind_TPSL_Period   = PERIOD_CURRENT;
input  string   STT                        = "Trade Time";//================================
input  short    Start_Trade                = 0;
input  short    Stop_Trade                 = 22;
input  string   FB                         = "parameters FiboBars";//================================
input  int      period                     = 100;
input  double   fibolevel                  = 0.236;
input  string   PP                         = "parameters Pivot Point";//================================
input  int      InpPivotType               = 0; //  / Type pivot
input  int      InpPivotPeriod             = 0;   // / Period
input  string   BB                         = "parametrs Bollinger Bands";//================================
input  int      InpBandsPeriod             = 20;       // Period
input  double   InpBandsDeviations         = 2.0;  // Deviation
input  string   MTS                        = "Matrix TP & SL";//================================
input  bool     enter_tp_allow             = false;
input  bool     enter_sl_allow             = false;
input  bool     edit_tp_allow              = false;
input  bool     edit_sl_allow              = false;

input  string    ManyManagment             = "===   MM ===";
input    bool    UseMM_Default             = false;
input    uint    LotsDepoForOne            = 300;
input    uint    LotsDeltaDepo             = 800;
input    uint    DrawalForOne              = 1000;
input    uint    DrawalDelta               = 500;
input    double  BalanseSlopeCriterion     = 1000.0;

input string     WithDrawal               = "===   WithDrawal ===";
input  bool       WDR_ENABLE               =    false; //    
input  wdr_period WDR_PERIOD               =   weeks; //   
//input double     WDR_VALUE                   =       1; //   
//+------------------------------------------------------------------+
int OnInit()
  {
   InitModels();
   criterion_Ptr=new TCustomCriterionArray();
   if(CheckPointer(criterion_Ptr)==POINTER_INVALID)
     {
      return(-1);
     }
   criterion_Ptr.Add(new TBalanceSlopeCriterion(Symbol(),BalanseSlopeCriterion));  
   wdr_summa = 0;
   wdr_count = 0;
   wdr_value = 0;
   initial_deposit = MathMax(DrawalForOne+DrawalDelta,AccountInfoDouble(ACCOUNT_BALANCE));  
   SymbolInfoTick(_Symbol, new_tick);
   dt_debit = new_tick.time;
   days_delay = Calc_Delay();    
   EventSetTimer(5);
   return(0);
  }
//+------------------------------------------------------------------+
//	  -:
//---------------------------------------------------------------------
void  OnDeinit(const int _reason)
  {
   if(CheckPointer(criterion_Ptr)==POINTER_DYNAMIC)
     {
      delete(criterion_Ptr);
     }
   delete list_model;                     //       
  }
//---------------------------------------------------------------------
//	      :
//---------------------------------------------------------------------
double  OnTester()
  {
   double  param=0.0;
   double  trades_number = TesterStatistics(STAT_TRADES);
   double  withdrawal    = TesterStatistics(STAT_WITHDRAWAL); 
   double  profit        = TesterStatistics(STAT_PROFIT); 
   double  balanceslope = 0.0;
   
   if(CheckPointer(criterion_Ptr)!=POINTER_INVALID)
     {
      //balanceslope=criterion_Ptr.GetCriterion();
     }
   if(profit-withdrawal<0)
   {
      param = 0;
   }
   else
   {
      param = (withdrawal/100)*10000+NormalizeDouble((profit-withdrawal)/100,0)*10+trades_number/100;
   }
   return(param);
  }

void OnTick()
{
   SymbolInfoTick(_Symbol, new_tick);
   CModel *model;                         //     
   for(int i=0;i<list_model.Total();i++)
     { //      
      model=list_model.GetNodeAtIndex(i); //       
      model.Processing();                 //     
     }
   TimeOfWithDrawal();  
}  
  
//+------------------------------------------------------------------+  
void OnTimer()
  {
  /*
   SymbolInfoTick(_Symbol, new_tick);
   CModel *model;                         //     
   for(int i=0;i<list_model.Total();i++)
     { //      
      model=list_model.GetNodeAtIndex(i); //       
      model.Processing();                 //     
     }
   TimeOfWithDrawal();  
   */
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//---     
//+------------------------------------------------------------------+
bool TimeOfWithDrawal()
//+------------------------------------------------------------------+
  {
   if(!WDR_ENABLE) return(false); // ,    
   
   if( new_tick.time > dt_debit + days_delay * DAY) //     
     {
      dt_debit = dt_debit + days_delay * DAY;
      days_delay = Calc_Delay();//    -     
      
      //if(WDR_TYPE == fixed) wdr_value = WDR_VALUE;
      //else 
      int k=DrawalForOne;
      wdr_value = 0;
      for (double i=2; i<=99; i++)
      {
         k=k+i*DrawalDelta;
         if (k>AccountInfoDouble(ACCOUNT_BALANCE))
         {
            wdr_value=(i-1)*100; 
            break;
         }
      }      
      if(AccountInfoDouble(ACCOUNT_BALANCE)-wdr_value>initial_deposit)
      {
         if(TesterWithdrawal(wdr_value))
           {
            wdr_count++;
            wdr_summa = wdr_summa + wdr_value;
            //initial_deposit = k;
            return(true);
           }
      }
     }
   return(false);
  }
  
  //+------------------------------------------------------------------+
uint Calc_Delay()
//+------------------------------------------------------------------+
{
   int month;
   int delay;
   MqlDateTime mqldt_debit;
   
   TimeToStruct(dt_debit, mqldt_debit);//     

   //---       
   switch(WDR_PERIOD)
   {
      case  days: delay = 1; break;
      case weeks: delay = 7; break;
   
      case months:
      case quarters:
      case halfyears:
      case years:             
            
            delay = 0;   
            for(int i= -1; i<WDR_PERIOD-1; i++)
            {
               month = mqldt_debit.mon + i;
               if (month > 11) month = month - 12;
               delay = delay + days_in_month[month];
            }
            break;
   }// end switch
   return(delay);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void InitModels()
  {
   list_model = new CList;             //    
   cmodel_ss *model_ss;            //     London

//----------------------------------------LONDON DEFAULT----------------------------------------
   if(ss_default==true)
     {
      model_ss=new cmodel_ss; //    LONDON
                                  //    
      if(model_ss.Init(
         777,
         "SS Model",
         _Symbol,
         _Period,
         "SS",
         SOT,
         System_Order_Type,
         System_Type,
         EnterParameters,
         enter_y,
         enter_ind,
         enter_ind_line,
         EditParameters,
         edit_y,
         edit_ind,
         edit_ind_line,
         ExitParameters,
         exit_y,
         exit_ind,
         exit_ind_line,
         TPSL_Enter,
         enter_tpsl_y,
         enter_tpsl_ind,
         enter_tp_ind_line,
         enter_sl_ind_line,
         TPSL_Edit,
         edit_tpsl_y,
         edit_tpsl_ind,
         edit_tp_ind_line,
         edit_sl_ind_line,
         STT,
         Start_Trade,
         Stop_Trade,
         FB,
         period,
         fibolevel,
         PP,
         InpPivotType,
         InpPivotPeriod,
         BB,
         InpBandsPeriod,
         InpBandsDeviations,
         MTS,
         enter_tp_allow,
         enter_sl_allow,
         edit_tp_allow,
         edit_sl_allow,
         ManyManagment,
         UseMM_Default,
         LotsDepoForOne,
         LotsDeltaDepo,
         DrawalForOne,
         DrawalDelta,
         BalanseSlopeCriterion,
         WithDrawal,
         WDR_ENABLE,
         WDR_PERIOD
      
         ))
        {

         Print("Print(Model ",model_ss.Name()," with period = ",model_ss.Period(),
               " on symbol ",model_ss.Symbol()," successfully created");
         list_model.Add(model_ss);//     
        }
      else
        {
         //     
         Print("Print(Model ",model_ss.Name()," with period = ",model_ss.Period(),
               " on symbol ",model_ss.Symbol()," great was failed");
        }
     }
//-------------------------------------------------------------------------------------------
//----------------------------------------SS BEST------------------------------------------
  

//----------------------------------------------------------------------------------------------
  }