//+------------------------------------------------------------------+
//|                                                      ProjectName |
//|                                      Copyright 2010, CompanyName |
//|                                       http://www.companyname.net |
//+------------------------------------------------------------------+
#include <Models\Model.mqh>
#include <mm.mqh>

enum   wdr_period
  {
   days      = -2, // 
   weeks     = -1, //  
   months    =  1, //   
   quarters  =  3, // 
   halfyears =  6, //     
   years     = 12  //     
  };
//+----------------------------------------------------------------------+
//| This model use london bands. 
//| Buy when price is lower than lower band
//| Sell when price is higher than upper band
//+----------------------------------------------------------------------+  
struct cmodel_ss_param
  {
   ulong             p_magic             ;
   string            p_model_name        ;  
   string            p_symbol            ;
   ENUM_TIMEFRAMES   p_timeframe         ;
   string            p_ind_name          ;
//--- input parameters
   string   p_SOT                        ;//================================
   ENUM_ORDER_TYPE p_System_Order_Type   ;
   short    p_System_Type                ;
   string   p_EnterParameters            ;//================================
   short    p_enter_y                    ;
   short    p_enter_ind                  ;
   short    p_enter_ind_line             ;
   string   p_EditParameters             ;//================================
   short    p_edit_y                     ;
   short    p_edit_ind                   ;
   short    p_edit_ind_line              ;
   string   p_ExitParameters             ;//================================
   short    p_exit_y                     ;
   short    p_exit_ind                   ;
   short    p_exit_ind_line              ;
   string   p_TPSL_Enter                 ;//================================
   short    p_enter_tpsl_y               ;
   short    p_enter_tpsl_ind             ;
   short    p_enter_tp_ind_line          ;
   short    p_enter_sl_ind_line          ;
   string   p_TPSL_Edit                  ;//================================
   short    p_edit_tpsl_y                ;
   short    p_edit_tpsl_ind               ;
   short    p_edit_tp_ind_line           ;
   short    p_edit_sl_ind_line           ;

//input ENUM_TIMEFRAMES    Ind_TPSL_Period   = PERIOD_CURRENT;
   string   p_STT                        ;//================================
   short    p_Start_Trade                ;
   short    p_Stop_Trade                 ;
   string   p_FB                         ;//================================
   int      p_period                     ;
   double   p_fibolevel                  ;
   string   p_PP                         ;//================================
   int      p_InpPivotType               ; //  / Type pivot
   int      p_InpPivotPeriod             ;   // / Period
   string   p_BB                         ;//================================
   int      p_InpBandsPeriod             ;       // Period
   double   p_InpBandsDeviations         ;  // Deviation
   string   p_MTS                        ;//================================
   bool     p_enter_tp_allow             ;
   bool     p_enter_sl_allow             ;
   bool     p_edit_tp_allow              ;
   bool     p_edit_sl_allow              ;
   
   string   p_ManyManagment              ;//================================
   bool     p_UseMM                      ;
   uint     p_LotsDepoForOne             ;
   uint     p_LotsDeltaDepo              ;
   uint     p_DrawalForOne               ;
   uint     p_DrawalDelta                ;
   double   p_BalanseSlopeCriterion      ;
   
   string     p_WithDrawal               ;//================================
   bool       p_WDR_ENABLE               ; //    
   wdr_period p_WDR_PERIOD               ; //   
   //double     p_WDR_VALUE                   =       1; //      
  
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
class cmodel_ss : public CModel
  {
private:
   ulong             m_magic             ;
   string            m_model_name        ;  
   string            m_symbol            ;
   ENUM_TIMEFRAMES   m_timeframe         ;
   string            m_ind_name          ;
//--- input parameters
   string   m_SOT                        ;//================================
   ENUM_ORDER_TYPE m_System_Order_Type   ;
   short    m_System_Type                ;
   string   m_EnterParameters            ;//================================
   short    m_enter_y                    ;
   short    m_enter_ind                  ;
   short    m_enter_ind_line             ;
   string   m_EditParameters             ;//================================
   short    m_edit_y                     ;
   short    m_edit_ind                   ;
   short    m_edit_ind_line              ;
   string   m_ExitParameters             ;//================================
   short    m_exit_y                     ;
   short    m_exit_ind                   ;
   short    m_exit_ind_line              ;
   string   m_TPSL_Enter                 ;//================================
   short    m_enter_tpsl_y               ;
   short    m_enter_tpsl_ind             ;
   short    m_enter_tp_ind_line          ;
   short    m_enter_sl_ind_line          ;
   string   m_TPSL_Edit                  ;//================================
   short    m_edit_tpsl_y                ;
   short    m_edit_tpsl_ind              ;
   short    m_edit_tp_ind_line           ;
   short    m_edit_sl_ind_line           ;

//input ENUM_TIMEFRAMES    Ind_TPSL_Period   = PERIOD_CURRENT;
   string   m_STT                        ;//================================
   short    m_Start_Trade                ;
   short    m_Stop_Trade                 ;
   string   m_FB                         ;//================================
   int      m_period                     ;
   double   m_fibolevel                  ;
   string   m_PP                         ;//================================
   int      m_InpPivotType               ; //  / Type pivot
   int      m_InpPivotPeriod             ;   // / Period
   string   m_BB                         ;//================================
   int      m_InpBandsPeriod             ;       // Period
   double   m_InpBandsDeviations         ;  // Deviation
   string   m_MTS                        ;//================================
   bool     m_enter_tp_allow             ;
   bool     m_enter_sl_allow             ;
   bool     m_edit_tp_allow              ;
   bool     m_edit_sl_allow              ;
   
   string   m_ManyManagment              ;//================================
   bool     m_UseMM                      ;
   uint     m_LotsDepoForOne             ;
   uint     m_LotsDeltaDepo              ;
   uint     m_DrawalForOne               ;
   uint     m_DrawalDelta                ;
   double   m_BalanseSlopeCriterion      ;
   
   string     m_WithDrawal               ;//================================
   bool       m_WDR_ENABLE               ; //    
   wdr_period m_WDR_PERIOD               ; //   
   //double     m_WDR_VALUE                   =       1; //      
   
   //-----------------------------------------
   int               m_handle;
   double            m_enterbuffer[1];
   double            m_editbuffer[1];
   double            m_exitbuffer[1]; 
      
   MqlRates          m_raters[];
   double            m_current_price;
   double            m_day_open_price;

public:
                     cmodel_ss();
   bool              Init();
   bool              Init(cmodel_ss_param &m_param);
   bool              Init
   (
   ulong             init_magic             ,
   string            init_model_name        , 
   string            init_symbol            ,
   ENUM_TIMEFRAMES   init_timeframe         ,
   string            init_ind_name          ,
   string   init_SOT                        ,
   ENUM_ORDER_TYPE init_System_Order_Type   ,
   short    init_System_Type                ,
   string   init_EnterParameters            ,
   short    init_enter_y                    ,
   short    init_enter_ind                  ,
   short    init_enter_ind_line             ,
   string   init_EditParameters             ,
   short    init_edit_y                     ,
   short    init_edit_ind                   ,
   short    init_edit_ind_line              ,
   string   init_ExitParameters             ,
   short    init_exit_y                     ,
   short    init_exit_ind                   ,
   short    init_exit_ind_line              ,
   string   init_TPSL_Enter                 ,
   short    init_enter_tpsl_y               ,
   short    init_enter_tpsl_ind             ,
   short    init_enter_tp_ind_line          ,
   short    init_enter_sl_ind_line          ,
   string   init_TPSL_Edit                  ,
   short    init_edit_tpsl_y                ,
   short    init_edit_tpsl_ind               ,
   short    init_edit_tp_ind_line           ,
   short    init_edit_sl_ind_line           ,
   string   init_STT                        ,
   short    init_Start_Trade                ,
   short    init_Stop_Trade                 ,
   string   init_FB                         ,
   int      init_period                     ,
   double   init_fibolevel                  ,
   string   init_PP                         ,
   int      init_InpPivotType               ,
   int      init_InpPivotPeriod             ,
   string   init_BB                         ,
   int      init_InpBandsPeriod             ,
   double   init_InpBandsDeviations         ,
   string   init_MTS                        ,
   bool     init_enter_tp_allow             ,
   bool     init_enter_sl_allow             ,
   bool     init_edit_tp_allow              ,
   bool     init_edit_sl_allow              ,
   string   init_ManyManagment              ,
   bool     init_UseMM                      ,
   uint     init_LotsDepoForOne             ,
   uint     init_LotsDeltaDepo              ,
   uint     init_DrawalForOne               ,
   uint     init_DrawalDelta                ,
   double   init_BalanseSlopeCriterion      ,
   string     init_WithDrawal               ,
   bool       init_WDR_ENABLE               ,
   wdr_period init_WDR_PERIOD               
   
   );
   bool              Processing();
protected:
   bool              InitIndicators();
   bool              OrderOpened();
   bool              OrderClosed();

   //---  
   double            CountLotByRisk(); //      
   double            NormalLot(double lot);          //        
   double            NormalDbl(double d, int n=-1);  //    
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
cmodel_ss::cmodel_ss()
  {
   m_handle          = INVALID_HANDLE;

   ArraySetAsSeries(m_enterbuffer,true);
   ArraySetAsSeries(m_editbuffer,true);
   ArraySetAsSeries(m_exitbuffer,true);   
 
   ArraySetAsSeries(m_raters,true);
   
   ArrayInitialize(m_enterbuffer,0);
   ArrayInitialize(m_editbuffer,0);
   ArrayInitialize(m_exitbuffer,0);

  }
//this default loader
bool cmodel_ss::Init()
  {
   m_magic                      = 777;
   m_model_name                 = "ss Model";  
   m_symbol                     = "EURUSD";
   m_timeframe                  = PERIOD_H1;
   m_ind_name                   = "SS";
   //--- input parameters
   m_SOT                        = "System Order Type";//================================
   m_System_Order_Type          = ORDER_TYPE_BUY;
   m_System_Type                = 0;
   m_EnterParameters            = "Enter ";//================================
   m_enter_y                    = 0;
   m_enter_ind                  = 0;
   m_enter_ind_line             = 0;
   m_EditParameters             = "Edit ";//================================
   m_edit_y                     = 0;
   m_edit_ind                   = 0;
   m_edit_ind_line              = 0;
   m_ExitParameters             = "Exit ";//================================
   m_exit_y                     = 0;
   m_exit_ind                   = 0;
   m_exit_ind_line              = 0;
   m_TPSL_Enter                 = "TPSL Enter";//================================
   m_enter_tpsl_y               = 0;
   m_enter_tpsl_ind             = 0;
   m_enter_tp_ind_line          = 4;
   m_enter_sl_ind_line          = 1;
   m_TPSL_Edit                  = "TPSL Edit";//================================
   m_edit_tpsl_y                = 0;
   m_edit_tpsl_ind              = 0;
   m_edit_tp_ind_line           = 4;
   m_edit_sl_ind_line           = 1;
   
   //input ENUM_TIMEFRAMES    Ind_TPSL_Period   = PERIOD_CURRENT;
   m_STT                        = "Trade Time";//================================
   m_Start_Trade                = 0;
   m_Stop_Trade                 = 22;
   m_FB                         = "parameters FiboBars";//================================
   m_period                     = 100;
   m_fibolevel                  = 0.236;
   m_PP                         = "parameters Pivot Point";//================================
   m_InpPivotType               = 0; //  / Type pivot
   m_InpPivotPeriod             = 0;   // / Period
   m_BB                         = "parametrs Bollinger Bands";//================================
   m_InpBandsPeriod             = 20;       // Period
   m_InpBandsDeviations         = 2.0;  // Deviation
   m_MTS                        = "Matrix TP & SL";//================================
   m_enter_tp_allow             = false;
   m_enter_sl_allow             = false;
   m_edit_tp_allow              = false;
   m_edit_sl_allow              = false;
   
   m_ManyManagment              = "===   MM ===";//================================
   m_UseMM                      = false;
   m_LotsDepoForOne             = 300;
   m_LotsDeltaDepo              = 800;
   m_DrawalForOne               = 1000;
   m_DrawalDelta                = 500;
   m_BalanseSlopeCriterion      = 1000.0;
   
   m_WithDrawal                 = "===   WithDrawal ===";//================================
   m_WDR_ENABLE                 = false; //    
   wdr_period m_WDR_PERIOD      = weeks; //   
   //double     m_WDR_VALUE                   =       1; //      
   
   if(!InitIndicators())return(false);
   return(true);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool cmodel_ss::Init(cmodel_ss_param &m_param)
  {
   m_magic                      = m_param.p_magic;
   m_model_name                 = m_param.p_model_name;  
   m_symbol                     = m_param.p_symbol;
   m_timeframe                  = m_param.p_timeframe;
   m_ind_name                   = m_param.p_ind_name;
   //--- input parameters
   m_SOT                        = m_param.p_SOT;//================================
   m_System_Order_Type          = m_param.p_System_Order_Type;
   m_System_Type                = m_param.p_System_Type;
   m_EnterParameters            = m_param.p_EnterParameters;//================================
   m_enter_y                    = m_param.p_enter_y;
   m_enter_ind                  = m_param.p_enter_ind;
   m_enter_ind_line             = m_param.p_enter_ind_line;
   m_EditParameters             = m_param.p_EditParameters;//================================
   m_edit_y                     = m_param.p_edit_y;
   m_edit_ind                   = m_param.p_edit_ind;
   m_edit_ind_line              = m_param.p_edit_ind_line;
   m_ExitParameters             = m_param.p_ExitParameters;//================================
   m_exit_y                     = m_param.p_exit_y;
   m_exit_ind                   = m_param.p_exit_ind;
   m_exit_ind_line              = m_param.p_exit_ind_line;
   m_TPSL_Enter                 = m_param.p_TPSL_Enter;//================================
   m_enter_tpsl_y               = m_param.p_enter_tpsl_y;
   m_enter_tpsl_ind             = m_param.p_enter_tpsl_ind;
   m_enter_tp_ind_line          = m_param.p_enter_tp_ind_line;
   m_enter_sl_ind_line          = m_param.p_enter_sl_ind_line;
   m_TPSL_Edit                  = m_param.p_TPSL_Edit;//================================
   m_edit_tpsl_y                = m_param.p_edit_tpsl_y;
   m_edit_tpsl_ind              = m_param.p_edit_tpsl_ind;
   m_edit_tp_ind_line           = m_param.p_edit_tp_ind_line;
   m_edit_sl_ind_line           = m_param.p_edit_sl_ind_line;
   
   //input ENUM_TIMEFRAMES    Ind_TPSL_Period   = PERIOD_CURRENT;
   m_STT                        = m_param.p_STT;//================================
   m_Start_Trade                = m_param.p_Start_Trade;
   m_Stop_Trade                 = m_param.p_Stop_Trade;
   m_FB                         = m_param.p_FB;//================================
   m_period                     = m_param.p_period;
   m_fibolevel                  = m_param.p_fibolevel;
   m_PP                         = m_param.p_PP;//================================
   m_InpPivotType               = m_param.p_InpPivotType; //  / Type pivot
   m_InpPivotPeriod             = m_param.p_InpPivotPeriod;   // / Period
   m_BB                         = m_param.p_BB;//================================
   m_InpBandsPeriod             = m_param.p_InpBandsPeriod;       // Period
   m_InpBandsDeviations         = m_param.p_InpBandsDeviations;  // Deviation
   m_MTS                        = m_param.p_MTS;//================================
   m_enter_tp_allow             = m_param.p_enter_tp_allow;
   m_enter_sl_allow             = m_param.p_enter_sl_allow;
   m_edit_tp_allow              = m_param.p_edit_tp_allow;
   m_edit_sl_allow              = m_param.p_edit_sl_allow;
   
   m_ManyManagment              = m_param.p_ManyManagment;//================================
   m_UseMM                      = m_param.p_UseMM;
   m_LotsDepoForOne             = m_param.p_LotsDepoForOne;
   m_LotsDeltaDepo              = m_param.p_LotsDeltaDepo;
   m_DrawalForOne               = m_param.p_DrawalForOne;
   m_DrawalDelta                = m_param.p_DrawalDelta;
   m_BalanseSlopeCriterion      = m_param.p_BalanseSlopeCriterion;
   
   m_WithDrawal                 = m_param.p_WithDrawal;//================================
   m_WDR_ENABLE                 = m_param.p_WDR_ENABLE; //    
   m_WDR_PERIOD                 = m_param.p_WDR_PERIOD; //   
   //double     m_WDR_VALUE                   =       1; //      
//if(!CheckParam(m_param))return(false);
   if(!InitIndicators())return(false);
   return(true);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool cmodel_ss::Init(
   ulong             init_magic             ,
   string            init_model_name        , 
   string            init_symbol            ,
   ENUM_TIMEFRAMES   init_timeframe         ,
   string            init_ind_name          ,
   string   init_SOT                        ,
   ENUM_ORDER_TYPE init_System_Order_Type   ,
   short    init_System_Type                ,
   string   init_EnterParameters            ,
   short    init_enter_y                    ,
   short    init_enter_ind                  ,
   short    init_enter_ind_line             ,
   string   init_EditParameters             ,
   short    init_edit_y                     ,
   short    init_edit_ind                   ,
   short    init_edit_ind_line              ,
   string   init_ExitParameters             ,
   short    init_exit_y                     ,
   short    init_exit_ind                   ,
   short    init_exit_ind_line              ,
   string   init_TPSL_Enter                 ,
   short    init_enter_tpsl_y               ,
   short    init_enter_tpsl_ind             ,
   short    init_enter_tp_ind_line          ,
   short    init_enter_sl_ind_line          ,
   string   init_TPSL_Edit                  ,
   short    init_edit_tpsl_y                ,
   short    init_edit_tpsl_ind               ,
   short    init_edit_tp_ind_line           ,
   short    init_edit_sl_ind_line           ,
   string   init_STT                        ,
   short    init_Start_Trade                ,
   short    init_Stop_Trade                 ,
   string   init_FB                         ,
   int      init_period                     ,
   double   init_fibolevel                  ,
   string   init_PP                         ,
   int      init_InpPivotType               ,
   int      init_InpPivotPeriod             ,
   string   init_BB                         ,
   int      init_InpBandsPeriod             ,
   double   init_InpBandsDeviations         ,
   string   init_MTS                        ,
   bool     init_enter_tp_allow             ,
   bool     init_enter_sl_allow             ,
   bool     init_edit_tp_allow              ,
   bool     init_edit_sl_allow              ,
   string   init_ManyManagment              ,
   bool     init_UseMM                      ,
   uint     init_LotsDepoForOne             ,
   uint     init_LotsDeltaDepo              ,
   uint     init_DrawalForOne               ,
   uint     init_DrawalDelta                ,
   double   init_BalanseSlopeCriterion      ,
   string     init_WithDrawal               ,
   bool       init_WDR_ENABLE               ,
   wdr_period init_WDR_PERIOD          
)
  {
   m_magic                      = init_magic;
   m_model_name                 = init_model_name;  
   m_symbol                     = init_symbol;
   m_timeframe                  = init_timeframe;
   m_ind_name                   = init_ind_name;
   //--- input parameters
   m_SOT                        = init_SOT;//================================
   m_System_Order_Type          = init_System_Order_Type;
   m_System_Type                = init_System_Type;
   m_EnterParameters            = init_EnterParameters;//================================
   m_enter_y                    = init_enter_y;
   m_enter_ind                  = init_enter_ind;
   m_enter_ind_line             = init_enter_ind_line;
   m_EditParameters             = init_EditParameters;//================================
   m_edit_y                     = init_edit_y;
   m_edit_ind                   = init_edit_ind;
   m_edit_ind_line              = init_edit_ind_line;
   m_ExitParameters             = init_ExitParameters;//================================
   m_exit_y                     = init_exit_y;
   m_exit_ind                   = init_exit_ind;
   m_exit_ind_line              = init_exit_ind_line;
   m_TPSL_Enter                 = init_TPSL_Enter;//================================
   m_enter_tpsl_y               = init_enter_tpsl_y;
   m_enter_tpsl_ind             = init_enter_tpsl_ind;
   m_enter_tp_ind_line          = init_enter_tp_ind_line;
   m_enter_sl_ind_line          = init_enter_sl_ind_line;
   m_TPSL_Edit                  = init_TPSL_Edit;//================================
   m_edit_tpsl_y                = init_edit_tpsl_y;
   m_edit_tpsl_ind              = init_edit_tpsl_ind;
   m_edit_tp_ind_line           = init_edit_tp_ind_line;
   m_edit_sl_ind_line           = init_edit_sl_ind_line;
   
   //input ENUM_TIMEFRAMES    Ind_TPSL_Period   = PERIOD_CURRENT;
   m_STT                        = init_STT;//================================
   m_Start_Trade                = init_Start_Trade;
   m_Stop_Trade                 = init_Stop_Trade;
   m_FB                         = init_FB;//================================
   m_period                     = init_period;
   m_fibolevel                  = init_fibolevel;
   m_PP                         = init_PP;//================================
   m_InpPivotType               = init_InpPivotType; //  / Type pivot
   m_InpPivotPeriod             = init_InpPivotPeriod;   // / Period
   m_BB                         = init_BB;//================================
   m_InpBandsPeriod             = init_InpBandsPeriod;       // Period
   m_InpBandsDeviations         = init_InpBandsDeviations;  // Deviation
   m_MTS                        = init_MTS;//================================
   m_enter_tp_allow             = init_enter_tp_allow;
   m_enter_sl_allow             = init_enter_sl_allow;
   m_edit_tp_allow              = init_edit_tp_allow;
   m_edit_sl_allow              = init_edit_sl_allow;
   
   m_ManyManagment              = init_ManyManagment;//================================
   m_UseMM                      = init_UseMM;
   m_LotsDepoForOne             = init_LotsDepoForOne;
   m_LotsDeltaDepo              = init_LotsDeltaDepo;
   m_DrawalForOne               = init_DrawalForOne;
   m_DrawalDelta                = init_DrawalDelta;
   m_BalanseSlopeCriterion      = init_BalanseSlopeCriterion;
   
   m_WithDrawal                 = init_WithDrawal;//================================
   m_WDR_ENABLE                 = init_WDR_ENABLE; //    
   m_WDR_PERIOD                 = init_WDR_PERIOD; //   
   //double     m_WDR_VALUE                   =       1; //      
   
   if(!InitIndicators())return(false);
   return(true);
  }

bool cmodel_ss::InitIndicators()
  {
   if(m_handle==INVALID_HANDLE)
     {
     Print("Load indicator "+m_ind_name);
     /*
     if((m_handle=iCustom(
         m_symbol                     ,
         m_timeframe                  ,
         m_ind_name                   ,
         m_SOT                        ,
         m_System_Order_Type          ,
         m_System_Type                ,
         m_EnterParameters            ,
         m_enter_y                    ,
         m_enter_ind                  ,
         m_enter_ind_line             ,
         m_EditParameters             ,
         m_edit_y                     ,
         m_edit_ind                   ,
         m_edit_ind_line              ,
         m_ExitParameters             ,
         m_exit_y                     ,
         m_exit_ind                   ,
         m_exit_ind_line              ,
         m_TPSL_Enter                 ,
         m_enter_tpsl_y               ,
         m_enter_tpsl_ind             ,
         m_enter_tp_ind_line          ,
         m_enter_sl_ind_line          ,
         m_TPSL_Edit                  ,
         m_edit_tpsl_y                ,
         m_edit_tpsl_ind              ,
         m_edit_tp_ind_line           ,
         m_edit_sl_ind_line           ,
         m_STT                        ,
         m_Start_Trade                ,
         m_Stop_Trade                 ,
         m_FB                         ,
         m_period                     ,
         m_fibolevel                  ,
         m_PP                         ,
         m_InpPivotType               ,
         m_InpPivotPeriod             ,
         m_BB                         ,
         m_InpBandsPeriod             ,
         m_InpBandsDeviations         ,
         m_MTS                        ,
         m_enter_tp_allow             ,
         m_enter_sl_allow             ,
         m_edit_tp_allow              ,
         m_edit_sl_allow              
       ))==INVALID_HANDLE)
       */
       m_handle = iCustom(
         m_symbol                     ,
         m_timeframe                  ,
         "SS"                         ,
         m_SOT                        ,
         m_System_Order_Type);
         /*          ,
         m_System_Type                ,
         m_EnterParameters            ,
         m_enter_y                    ,
         m_enter_ind                  ,
         m_enter_ind_line             ,
         m_EditParameters             ,
         m_edit_y                     ,
         m_edit_ind                   ,
         m_edit_ind_line              ,
         m_ExitParameters             ,
         m_exit_y                     ,
         m_exit_ind                   ,
         m_exit_ind_line              ,
         m_TPSL_Enter                 ,
         m_enter_tpsl_y               ,
         m_enter_tpsl_ind             ,
         m_enter_tp_ind_line          ,
         m_enter_sl_ind_line          ,
         m_TPSL_Edit                  ,
         m_edit_tpsl_y                ,
         m_edit_tpsl_ind              ,
         m_edit_tp_ind_line           ,
         m_edit_sl_ind_line           ,
         m_STT                        ,
         m_Start_Trade                ,
         m_Stop_Trade                 ,
         m_FB                         ,
         m_period                     ,
         m_fibolevel                  ,
         m_PP                         ,
         m_InpPivotType               ,
         m_InpPivotPeriod             ,
         m_BB                         ,
         m_InpBandsPeriod             ,
         m_InpBandsDeviations         ,
         m_MTS                        ,
         m_enter_tp_allow             ,
         m_enter_sl_allow             ,
         m_edit_tp_allow              ,
         m_edit_sl_allow              
);
*/
       if(m_handle==INVALID_HANDLE)
        {
         //Print("Error in creation of SS indicator.");
         Print(m_ind_name," Init Error =",GetLastError(),"!!");
         Print("Symbol ",_Symbol,"  Period ",_Period,"  Name ",m_ind_name);
         return(false);
         }
     }     
   return(true);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool cmodel_ss::Processing()
  {
   //if(timing(m_symbol,m_timeframe, m_timing)==false)return(false);
   
   //if(m_symbol_info.TradeMode()==SYMBOL_TRADE_MODE_DISABLED)return(false);
   //if(m_account_info.TradeAllowed()==false)return(false);
   if(m_account_info.TradeExpert()==false)return(false);
   
   m_symbol_info.Name(m_symbol);
   m_symbol_info.RefreshRates();
   //Copy last data of moving average

   GetNumberOrders(m_orders);
   
   switch(m_System_Order_Type)
   {  
      case ORDER_TYPE_BUY :
      {
         if(m_orders.buy_orders>0) 
            OrderClosed();
         else                        
            OrderOpened();
         break;   
      }
      case ORDER_TYPE_SELL :
      {
         if(m_orders.sell_orders>0) 
            OrderClosed();
         else                        
            OrderOpened();
         break;   
      }
   }
   return(true);
  }
  
//---  
double cmodel_ss::NormalDbl(double d,int n=-1) {  if(n<0) return(::NormalizeDouble(d,m_symbol_info.Digits())); return(NormalizeDouble(d,n)); }
//---------------------------------------------------------------   NL
double cmodel_ss::NormalLot(double lot)
  {
   int k=1;
   double ll=lot,ls=m_symbol_info.LotsStep();
   //if(ls<=0.001) k=3; else if(ls<=0.01) k=2; else if(ls<=0.1) k=1;
   ll=NormalDbl(MathMin(m_symbol_info.LotsMax(),MathMax(m_symbol_info.LotsMin(),ll)),k);
   return(ll);
  }
//---------------------------------------------------------------   CountLotByRisk
double cmodel_ss::CountLotByRisk() //     
  {
   double lot_result;
   //if(dist==0 || risk==0) return(lot);
   m_symbol_info.Refresh();
   int k=m_LotsDepoForOne;
   for (double i=2; i<=m_symbol_info.LotsMax(); i++)
   {
      k=k+i*m_LotsDeltaDepo;
      if (k>AccountInfoDouble(ACCOUNT_EQUITY))
      {
         lot_result=(i-1)/10; 
         break;
      }
   }   
   //lot_result = NormalLot(AccountInfoDouble(ACCOUNT_BALANCE)*risk/(dist*10*m_symbol_info.TickValue()));
   lot_result = NormalLot(lot_result);
   return(lot_result);
  }  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool cmodel_ss::OrderOpened(void)
  {
   //if(m_symbol_info.TradeMode()==SYMBOL_TRADE_MODE_DISABLED)return(false);
   //if(m_symbol_info.TradeMode()==SYMBOL_TRADE_MODE_SHORTONLY)return(false);
   //if(m_symbol_info.TradeMode()==SYMBOL_TRADE_MODE_CLOSEONLY)return(false);
   //Print("Model london: ", m_orders.buy_orders);
   bool   rezult,time_buy=true;
   double lot=0.1;
   double sl=0.0;
   double tp=0.0;
   string msg_subj,msg_text;

   mm open_mm;
   m_symbol_info.Name(m_symbol);
   m_symbol_info.RefreshRates();

   if (CopyBuffer(m_handle,0,1,1,m_enterbuffer)==-1) return(false); 

   if(m_enterbuffer[0]!=0&&m_enterbuffer[0]!=EMPTY_VALUE)
     {
       Print("   : ","m_handle="+m_handle+" m_enterbuffer="+m_enterbuffer[0]);
      //tp=NormalizeDouble(m_london_buff_high[0]+(m_london_buff_high[0]-m_london_buff_low[0])*m_Koef,_Digits);
      //lot=open_mm.optimal_f(m_symbol,ORDER_TYPE_BUY,m_symbol_info.Ask(),sl,m_risk);
      if(m_UseMM)
      {
      lot = CountLotByRisk();
      lot = MathMin(lot,33);//open_mm.CheckLot(m_symbol, lot, ORDER_TYPE_BUY);
      lot = open_mm.CheckMargin(m_symbol, ORDER_TYPE_BUY, lot, m_symbol_info.Ask());
      }
      else lot = 0.1;
      
      switch(m_System_Order_Type)
      {
         case ORDER_TYPE_BUY :
         {
            rezult=SendOrder(m_symbol,ORDER_TYPE_BUY,ORDER_ADD,0,lot,m_symbol_info.Ask(),sl,tp,"Buy:TP="+DoubleToString(tp,_Digits)+";SL="+DoubleToString(sl,_Digits));
            break;            
         }        
         case ORDER_TYPE_SELL :
         {
            rezult=SendOrder(m_symbol,ORDER_TYPE_SELL,ORDER_ADD,0,lot,m_symbol_info.Bid(),sl,tp,"Sell:TP="+DoubleToString(tp,_Digits)+";SL="+DoubleToString(sl,_Digits));
            break;            
         }                 
      }
      return(rezult);
     }
   return(false);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool cmodel_ss::OrderClosed(void)
  {
   if(m_symbol_info.TradeMode()==SYMBOL_TRADE_MODE_DISABLED)return(false);
   CTableOrders *t;
   int total_elements;
   int rez=false;
   MqlDateTime cur_time, order_time;
   
   total_elements=ListTableOrders.Total();
   if(total_elements==0)return(false);

   if (CopyBuffer(m_handle,2,1,1,m_exitbuffer) ==-1) return(false);

   for(int i=total_elements-1;i>=0;i--)
     {
      if(CheckPointer(ListTableOrders)==POINTER_INVALID)continue;
      t=ListTableOrders.GetNodeAtIndex(i);
      if(CheckPointer(t)==POINTER_INVALID)continue;
      if(t.Type()!= m_System_Order_Type) continue;
      //if(t.Magic()!= m_magic) continue;

      m_symbol_info.Refresh();
      m_symbol_info.RefreshRates();
      TimeToStruct(t.TimeSetup(),order_time);
      TimeToStruct(m_symbol_info.Time(),cur_time); 
      if(m_exitbuffer[0]!=0&&m_exitbuffer[0]!=EMPTY_VALUE)
      {
         Print("   : ","m_handle="+m_handle+" m_enterbuffer="+m_exitbuffer[0]);
         switch(m_System_Order_Type)
         {
            case ORDER_TYPE_BUY :
            {
               rez=SendOrder(m_symbol,ORDER_TYPE_SELL,ORDER_DELETE,t.Ticket(),t.VolumeInitial(),m_symbol_info.Bid(),0.0,0.0,"BUY: closed by signal");
               break;            
            }        
            case ORDER_TYPE_SELL :
            {
               rez=SendOrder(m_symbol,ORDER_TYPE_BUY,ORDER_DELETE,t.Ticket(),t.VolumeInitial(),m_symbol_info.Ask(),0.0,0.0,"SELL: closed by signal");
               break;            
            }                 
         }
      }
      
     }

   return(rez);
  }
//+------------------------------------------------------------------+
