//+------------------------------------------------------------------+
//|                                                     FiboBars.mq5 |
//|                        Copyright 2012, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2012, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
#property indicator_chart_window
#property indicator_buffers 8
#property indicator_plots   3


//--- plot Medium
#property indicator_label1  "Buy"
#property indicator_type1   DRAW_ARROW
#property indicator_color1  clrDarkBlue
#property indicator_style1  STYLE_SOLID
#property indicator_width1  1

//--- plot UpTrend
#property indicator_label2  "Sell"
#property indicator_type2   DRAW_ARROW
#property indicator_color2  clrRed
#property indicator_style2  STYLE_SOLID
#property indicator_width2  1
/*
//--- plot DnTrend
#property indicator_label3  "DnTrend"
#property indicator_type3   DRAW_ARROW
#property indicator_color3  clrDarkBlue
#property indicator_style3  STYLE_SOLID
#property indicator_width3  2
/*
//--- plot High
#property indicator_label4  "High"
#property indicator_type4   DRAW_COLOR_CANDLES
#property indicator_color4  clrRed
#property indicator_style4  STYLE_SOLID
#property indicator_width4  1
//--- plot Low
#property indicator_label5  "Low"
#property indicator_type5   DRAW_COLOR_CANDLES
#property indicator_color5  clrRed
#property indicator_style5  STYLE_SOLID
#property indicator_width5  1
//--- plot Open
#property indicator_label6  "Open"
#property indicator_type6   DRAW_COLOR_CANDLES
#property indicator_color6  clrRed
#property indicator_style6  STYLE_SOLID
#property indicator_width6  1
//--- plot Close
#property indicator_label7  "Close"
#property indicator_type7   DRAW_COLOR_CANDLES
#property indicator_color7  clrRed
#property indicator_style7  STYLE_SOLID
#property indicator_width7  1
*/
//--- plot Color
#property indicator_label3  "Color"
#property indicator_type3   DRAW_COLOR_CANDLES
//#property indicator_color1  clrRed,clrBlue
//#property indicator_style1  STYLE_SOLID
#property indicator_width3  1

#define MODE_OPEN 0
#define MODE_CLOSE 3
#define MODE_LOW 1
#define MODE_HIGH 2
#define MODE_TIME 5
#define MODE_VOLUME 4 


//--- input parameters
input int      period=100;
input double   fibolevel=0.236;

//----      
int StartBars;
double maxHigh;
double minLow;
//--- indicator buffers
double         SignalBuyBuffer[];
double         SignalSellBuffer[];
double         HighBuffer[];
double         LowBuffer[];
double         OpenBuffer[];
double         CloseBuffer[];
double         ColorBuffer[];
double         TrendBuffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   StartBars=period+1;
   SetIndexBuffer(0,SignalBuyBuffer,INDICATOR_DATA);
   SetIndexBuffer(1,SignalSellBuffer,INDICATOR_DATA);
   //SetIndexBuffer(2,DnTrendBuffer,INDICATOR_DATA);
   SetIndexBuffer(2,HighBuffer,INDICATOR_DATA);
   SetIndexBuffer(3,LowBuffer,INDICATOR_DATA);
   SetIndexBuffer(4,OpenBuffer,INDICATOR_DATA);
   SetIndexBuffer(5,CloseBuffer,INDICATOR_DATA);
   SetIndexBuffer(6,ColorBuffer,INDICATOR_COLOR_INDEX);  
   SetIndexBuffer(7,TrendBuffer,INDICATOR_CALCULATIONS);



   //Define the number of color indexes, used for a graphic plot
   PlotIndexSetInteger(2,PLOT_COLOR_INDEXES,3);

   //Set color for each index
   PlotIndexSetInteger(0,PLOT_ARROW,217);
   PlotIndexSetInteger(1,PLOT_ARROW,218);
   PlotIndexSetInteger(2,PLOT_LINE_COLOR,0,Red);   //Zeroth index -> Blue
   PlotIndexSetInteger(2,PLOT_LINE_COLOR,1,Green);    //First index  -> Orande
   PlotIndexSetInteger(2,PLOT_LINE_COLOR,-1,Black);    //First index  -> Orande   
   
   ArrayInitialize(SignalBuyBuffer,0);
   ArrayInitialize(SignalSellBuffer,0);
   ArrayInitialize(HighBuffer,0);
   ArrayInitialize(LowBuffer,0);
   ArrayInitialize(OpenBuffer,0);
   ArrayInitialize(CloseBuffer,0);
   ArrayInitialize(ColorBuffer,0);
   ArrayInitialize(TrendBuffer,0);
//---
   return(0);
  }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
//--- check if all data calculated
   //if(BarsCalculated(ma_handle)<rates_total) return(0);
//--- we can copy not all data
   int to_copy;
   if(prev_calculated>rates_total || prev_calculated<=0) to_copy=rates_total;
   else
     {
      to_copy=rates_total-prev_calculated;
      //--- last value is always copied
      to_copy++;
     }
//----       
   if(rates_total<StartBars) return(0);

//----   
   int first,i;

//----    first       
   if(prev_calculated>rates_total || prev_calculated<=0) //      
     {
      first=StartBars; //      
      for(int del=0;del<=rates_total-1;del++)
      {
         SignalBuyBuffer[del]=0;
         SignalSellBuffer[del]=0;
         HighBuffer[del]=0;
         LowBuffer[del]=0;
         OpenBuffer[del]=0;
         CloseBuffer[del]=0;
         ColorBuffer[del]=0;
         TrendBuffer[del]=0;
      }      
     }
   else first=prev_calculated-1; //      
   
//----   
   for(i=first; i<rates_total && !IsStopped(); i++)
     {     
        if(i == 88366 )
        {
         Print(""+DoubleToString(maxHigh,5)+": "+DoubleToString(minLow,5));
        }

        maxHigh=high[iHighest(high,period,i-1)];
        minLow=low[iLowest(low,period,i-1)];        
        if(open[i-1] > close[i-1]) {
           if(!(TrendBuffer[i-2] < 0  && (maxHigh - minLow) * fibolevel < (close[i-1] - minLow))) {
              TrendBuffer[i-1] = 1;
           } else {
              TrendBuffer[i-1] = -1;
           }          
        } else {
            if(!(TrendBuffer[i-2] > 0  && (maxHigh - minLow) * fibolevel < (maxHigh - close[i-1]))) {
                TrendBuffer[i-1] = -1;
            } else {
                TrendBuffer[i-1] = 1;
            }         
        }
        
        if(TrendBuffer[i-1] == 1) {//RED BAR 
            HighBuffer[i-1] = high[i-1];
            LowBuffer[i-1] = low[i-1]; 
            OpenBuffer[i-1] = MathMax(open[i-1], close[i-1]); 
            CloseBuffer[i-1] = MathMin(open[i-1], close[i-1]);   
            ColorBuffer[i-1] = 0;
            if(TrendBuffer[i-2]<TrendBuffer[i-1]) SignalSellBuffer[i-1] = high[i-2]; else SignalSellBuffer[i-1] = 0;
        } else if(TrendBuffer[i-1] == -1) {//GREEN BAR
            HighBuffer[i-1] = low[i-1];
            LowBuffer[i-1] = high[i-1]; 
            OpenBuffer[i-1] = MathMin(open[i-1], close[i-1]);  
            CloseBuffer[i-1] = MathMax(open[i-1], close[i-1]);    
            ColorBuffer[i-1] = 1;
            if(TrendBuffer[i-2]>TrendBuffer[i-1]) SignalBuyBuffer[i-1] = low[i-2]; else SignalBuyBuffer[i-1] = 0;
        } else {
            HighBuffer[i-1] = EMPTY_VALUE;
            LowBuffer[i-1] = EMPTY_VALUE; 
            OpenBuffer[i-1] = EMPTY_VALUE;  
            CloseBuffer[i-1] = EMPTY_VALUE;  
            ColorBuffer[i-1] = -1;
        }  
     
     }     
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
//|  searching index of the highest bar                              |
//+------------------------------------------------------------------+
int iHighest(const double &array[], //      
             int count,             //      (        ) 
             int startPos)          //  (   )  ,    
  {
//----
   int index=startPos;

//----     
   if(startPos<0)
     {
      Print("    iHighest, startPos = ",startPos);
      return(0);
     }

//----   startPos  
   if(startPos-count<0) count=startPos;

   double max=array[startPos];

//----  
   for(int i=startPos; i>startPos-count; i--)
     {
      if(array[i]>max)
        {
         index=i;
         max=array[i];
        }
     }
//----    
   return(index);
  }
//+------------------------------------------------------------------+
//|  searching index of the lowest bar                               |
//+------------------------------------------------------------------+
int iLowest(const double &array[], //      
             int count,            //      (        ) 
             int startPos)         //  (   )  ,    
  {
//----
   int index=startPos;

//----     
   if(startPos<0)
     {
      Print("    iLowest, startPos = ",startPos);
      return(0);
     }

//----   startPos  
   if(startPos-count<0)
      count=startPos;

   double min=array[startPos];

//----  
   for(int i=startPos; i>startPos-count; i--)
     {
      if(array[i]<min)
        {
         index=i;
         min=array[i];
        }
     }
//----    
   return(index);
  }
//+------------------------------------------------------------------+
  
  ENUM_TIMEFRAMES TFMigrate(int tf)
  {
   switch(tf)
     {
      case 0: return(PERIOD_CURRENT);
      case 1: return(PERIOD_M1);
      case 5: return(PERIOD_M5);
      case 15: return(PERIOD_M15);
      case 30: return(PERIOD_M30);
      case 60: return(PERIOD_H1);
      case 240: return(PERIOD_H4);
      case 1440: return(PERIOD_D1);
      case 10080: return(PERIOD_W1);
      case 43200: return(PERIOD_MN1);
      
      case 2: return(PERIOD_M2);
      case 3: return(PERIOD_M3);
      case 4: return(PERIOD_M4);      
      case 6: return(PERIOD_M6);
      case 10: return(PERIOD_M10);
      case 12: return(PERIOD_M12);
      case 16385: return(PERIOD_H1);
      case 16386: return(PERIOD_H2);
      case 16387: return(PERIOD_H3);
      case 16388: return(PERIOD_H4);
      case 16390: return(PERIOD_H6);
      case 16392: return(PERIOD_H8);
      case 16396: return(PERIOD_H12);
      case 16408: return(PERIOD_D1);
      case 32769: return(PERIOD_W1);
      case 49153: return(PERIOD_MN1);      
      default: return(PERIOD_CURRENT);
     }
  }