//+------------------------------------------------------------------+
//|                                                    universal.mq5 |
//|                        Copyright 2012, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2012, 1CMaster"
#property link      "http://www.mql5.com"
#property version   "2.00"
#property indicator_chart_window
#property indicator_buffers 8
#property indicator_plots   8

//--- plot Signal
#property indicator_label1  "Signal"
#property indicator_type1   DRAW_ARROW
#property indicator_color1  clrBlue,clrRed
#property indicator_style1  STYLE_SOLID
#property indicator_width1  1
//--- plot Change
#property indicator_label2  "Edit"
#property indicator_type2   DRAW_ARROW
#property indicator_color2  clrBlue,clrRed
#property indicator_style2  STYLE_SOLID
#property indicator_width2  1
//--- plot Stop
#property indicator_label3  "Stop"
#property indicator_type3   DRAW_ARROW
#property indicator_color3  clrBlue,clrRed
#property indicator_style3  STYLE_SOLID
#property indicator_width3  1
//--- plot TPBuy
#property indicator_label4  "TP"
#property indicator_type4   DRAW_ARROW
#property indicator_color4  clrBlue,clrRed
#property indicator_style4  STYLE_SOLID
#property indicator_width4  2
//--- plot SLBuy
#property indicator_label5  "SL"
#property indicator_type5   DRAW_ARROW
#property indicator_color5  clrBlue,clrRed
#property indicator_style5  STYLE_SOLID
#property indicator_width5  2
//--- plot TPChange
#property indicator_label6  "TPEdit"
#property indicator_type6   DRAW_ARROW
#property indicator_color6  clrBlue,clrRed
#property indicator_style6  STYLE_SOLID
#property indicator_width6  1
//--- plot SLChange
#property indicator_label7  "SLEdit"
#property indicator_type7   DRAW_ARROW
#property indicator_color7  clrBlue,clrRed
#property indicator_style7  STYLE_SOLID
#property indicator_width7  1
//--- plot EMPTYSIGNAL
#property indicator_label8  "Price"
#property indicator_type8   DRAW_ARROW
#property indicator_color8  clrAqua
#property indicator_style8  STYLE_SOLID
#property indicator_width8  1
//---  parameters
input string   SOT                        = "System Order Type";//================================
input  ENUM_ORDER_TYPE System_Order_Type   = ORDER_TYPE_SELL;
input   short    System_Type                = 2;
input   string   EnterParameters            = "Enter ";//================================
input   short    enter_y                    = 0;
input   short    enter_ind                  = 0;
input   short    enter_ind_line             = 1;
input   string   EditParameters             = "Edit ";//================================
input   short    edit_y                     = 0;
input   short    edit_ind                   = 0;
input   short    edit_ind_line              = 0;
input   string   ExitParameters             = "Exit ";//================================
input   short    exit_y                     = 3;
input   short    exit_ind                   = 0;
input   short    exit_ind_line              = 0;
input   string   TPSL_Enter                 = "TPSL Enter";//================================
input   short    enter_tpsl_y               = 0;
input   short    enter_tpsl_ind             = 0;
input   short    enter_tp_ind_line          = 4;
input   short    enter_sl_ind_line          = 1;
input   string   TPSL_Edit                  = "TPSL Edit";//================================
input   short    edit_tpsl_y                = 0;
input   short    edit_tpsl_ind              = 0;
input   short    edit_tp_ind_line           = 4;
input   short    edit_sl_ind_line           = 1;

// ENUM_TIMEFRAMES    Ind_TPSL_Period   = PERIOD_CURRENT;
input   string   STT                        = "Trade Time";//================================
input   short    Start_Trade                = 0;
input   short    Stop_Trade                 = 23;
input   string   FB                         = "parameters FiboBars";//================================
input   int      period                     = 100;
input   double   fibolevel                  = 0.236;
input   string   PP                         = "parameters Pivot Point";//================================
input   int      InpPivotType               = 0; //  / Type pivot
input   int      InpPivotPeriod             = 0;   // / Period
input   string   BB                         = "parametrs Bollinger Bands";//================================
input   int      InpBandsPeriod             = 20;       // Period
input   double   InpBandsDeviations         = 2.0;  // Deviation
input   string   MTS                        = "Matrix TP & SL";//================================
input   bool     enter_tp_allow             = false;
input   bool     enter_sl_allow             = false;
input   bool     edit_tp_allow              = false;
input   bool     edit_sl_allow              = false;



//--- indicator buffers
double         EnterBuffer[];
double         EditBuffer[];
double         ExitBuffer[];
double         TPEnterBuffer[];
double         SLEnterBuffer[];
double         TPEditBuffer[];
double         SLEditBuffer[];
double         EmptyBuffer[];

datetime       StartTimeBuffer[2];
datetime       StopTimeBuffer[2];
double         TradeAllow[2];

string         Symbols[12]= {"","EURUSD","GBPUSD","USDJPY","USDCAD","AUDUSD","NZDUSD","EURGBP","EURAUD","EURJPY","EURNZD","EURCAD"};

bool           EnterAllow, EditAllow, ExitAllow, TP_Enter_Allow, SL_Enter_Allow, TP_Edit_Allow, SL_Edit_Allow;
double         EnterSignal,EditSignal,ExitSignal,TP_Enter_Signal, SL_Enter_Signal, TP_Edit_Signal, SL_Edit_Signal;

//---    BB.mq5
int enter_ind_handle, enter_tpsl_ind_handle, edit_ind_handle, edit_tpsl_ind_handle, exit_ind_handle;
int bars,PrevBars;
int StartBars;
double buffer_tmp[1];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

int OnInit()
  {
   StartBars=MathMax(period,InpBandsPeriod)+1;
//--- indicator buffers mapping
   //SetIndexBuffer(0,StartBuffer,INDICATOR_DATA);
   //SetIndexBuffer(1,ExitBuffer,INDICATOR_DATA);
   SetIndexBuffer(0,EnterBuffer,INDICATOR_DATA);
   SetIndexBuffer(1,EditBuffer,INDICATOR_DATA);
   SetIndexBuffer(2,ExitBuffer,INDICATOR_DATA);
   SetIndexBuffer(3,TPEnterBuffer,INDICATOR_DATA);
   SetIndexBuffer(4,SLEnterBuffer,INDICATOR_DATA);
   SetIndexBuffer(5,TPEditBuffer,INDICATOR_DATA);     
   SetIndexBuffer(6,SLEditBuffer,INDICATOR_DATA); 
   SetIndexBuffer(7,EmptyBuffer,INDICATOR_DATA); 
   
   ArrayInitialize(EnterBuffer,0);
   ArrayInitialize(EditBuffer,0);
   ArrayInitialize(ExitBuffer,0);
   ArrayInitialize(TPEnterBuffer,0);
   ArrayInitialize(SLEnterBuffer,0);
   ArrayInitialize(TPEditBuffer,0);
   ArrayInitialize(SLEditBuffer,0);
   ArrayInitialize(EmptyBuffer,0);
   //ResetLastError();
   Ind_Enter(enter_ind,_Symbol,_Period,enter_ind_handle);
   Print("enter_ind_handle = ",enter_ind_handle,"  error = ",GetLastError());
   Ind_Edit(edit_ind,_Symbol,_Period,edit_ind_handle);
   Print("edit_ind_handle = ",edit_ind_handle,"  error = ",GetLastError());
   Ind_Exit(exit_ind,_Symbol,_Period,exit_ind_handle);
   Print("exit_ind_handle = ",exit_ind_handle,"  error = ",GetLastError());
   Ind_Enter_TPSL(enter_tpsl_ind,_Symbol,_Period,enter_tpsl_ind_handle);
   Print("enter_tpsl_ind_handle = ",enter_tpsl_ind_handle,"  error = ",GetLastError());
   Ind_Edit_TPSL(edit_tpsl_ind,_Symbol,_Period,edit_tpsl_ind_handle);
   Print("edit_tpsl_ind_handle = ",edit_tpsl_ind_handle,"  error = ",GetLastError());
   
 
//--- setting a code from the Wingdings charset as the property of PLOT_ARROW

   switch(System_Order_Type)
    {
      case ORDER_TYPE_BUY:// Buy color scheme
         {
            PlotIndexSetInteger(0,PLOT_LINE_COLOR,0,clrBlue);
            PlotIndexSetString(0,PLOT_LABEL,"Buy");
            PlotIndexSetInteger(1,PLOT_LINE_COLOR,0,clrBlue);
            PlotIndexSetString(1,PLOT_LABEL,"Buy_Edit");
            PlotIndexSetInteger(2,PLOT_LINE_COLOR,0,clrBlue);
            PlotIndexSetString(2,PLOT_LABEL,"Buy_Close");
            PlotIndexSetInteger(3,PLOT_LINE_COLOR,0,clrBlue);
            PlotIndexSetString(3,PLOT_LABEL,"Buy_TP");
            PlotIndexSetInteger(4,PLOT_LINE_COLOR,0,clrRed);
            PlotIndexSetString(4,PLOT_LABEL,"Buy_SL");
            PlotIndexSetInteger(5,PLOT_LINE_COLOR,0,clrBlue);
            PlotIndexSetString(5,PLOT_LABEL,"Buy_EDIT_TP");
            PlotIndexSetInteger(6,PLOT_LINE_COLOR,0,clrRed);
            PlotIndexSetString(6,PLOT_LABEL,"Buy_EDIT_SL");
            PlotIndexSetInteger(7,PLOT_LINE_COLOR,0,clrDarkGreen);
            PlotIndexSetString(0,PLOT_LABEL,"Price");
            PlotIndexSetInteger(0,PLOT_ARROW,221);
            PlotIndexSetInteger(1,PLOT_ARROW,121);
            PlotIndexSetInteger(2,PLOT_ARROW,120);
            PlotIndexSetInteger(3,PLOT_ARROW,158);
            PlotIndexSetInteger(4,PLOT_ARROW,158);
            PlotIndexSetInteger(5,PLOT_ARROW,158);
            PlotIndexSetInteger(6,PLOT_ARROW,158);   
            PlotIndexSetInteger(7,PLOT_ARROW,158);               
            break;
          }
      case ORDER_TYPE_SELL:// Sell color scheme
         {
            PlotIndexSetInteger(0,PLOT_LINE_COLOR,0,clrMaroon);
            PlotIndexSetString(0,PLOT_LABEL,"Sell");
            PlotIndexSetInteger(1,PLOT_LINE_COLOR,0,clrRed);
            PlotIndexSetString(1,PLOT_LABEL,"Sell_Edit");
            PlotIndexSetInteger(2,PLOT_LINE_COLOR,0,clrRed);
            PlotIndexSetString(2,PLOT_LABEL,"Sell_Close");
            PlotIndexSetInteger(3,PLOT_LINE_COLOR,0,clrOrange);
            PlotIndexSetString(3,PLOT_LABEL,"Sell_TP");
            PlotIndexSetInteger(4,PLOT_LINE_COLOR,0,clrViolet);
            PlotIndexSetString(4,PLOT_LABEL,"Sell_SL");
            PlotIndexSetInteger(5,PLOT_LINE_COLOR,0,clrFireBrick);
            PlotIndexSetString(5,PLOT_LABEL,"Sell_Edit_TP");
            PlotIndexSetInteger(6,PLOT_LINE_COLOR,0,clrGreen);
            PlotIndexSetString(6,PLOT_LABEL,"Sell_Edit_SL");
            PlotIndexSetInteger(7,PLOT_LINE_COLOR,0,clrDarkGreen);
            PlotIndexSetString(7,PLOT_LABEL,"Price");
            PlotIndexSetInteger(0,PLOT_ARROW,222);
            PlotIndexSetInteger(1,PLOT_ARROW,121);
            PlotIndexSetInteger(2,PLOT_ARROW,120);
            PlotIndexSetInteger(3,PLOT_ARROW,158);
            PlotIndexSetInteger(4,PLOT_ARROW,158);
            PlotIndexSetInteger(5,PLOT_ARROW,158);
            PlotIndexSetInteger(6,PLOT_ARROW,158);   
            PlotIndexSetInteger(7,PLOT_ARROW,158);               
            break;
          }             
     }  

   
//---
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime& time[],
                const double& open[],
                const double& high[],
                const double& low[],
                const double& close[],
                const long& tick_volume[],
                const long& volume[],
                const int& spread[])
  {
//---

/*
const int rates_total,
                const int prev_calculated,
                const int begin,
                const double &price[])
*/                
   string out;
   
//	   :
	//if( CheakNewBar( ) != 1 )
	//{
	//	return(rates_total);
	//}   
   
//--- check if all data calculated
   //if(BarsCalculated(ma_handle)<rates_total) return(0);
//--- we can copy not all data
   int to_copy;
   if(prev_calculated>rates_total || prev_calculated<=0) to_copy=rates_total;
   else
     {
      to_copy=rates_total-prev_calculated;
      //--- last value is always copied
      //to_copy++;
     }
//----       
   if(rates_total<StartBars) return(0);

//----   
   int first,i;

//----    first       
   if(prev_calculated>rates_total || prev_calculated<=0) //      
     {
      first=StartBars; //      
      for(int del=0;del<=rates_total-1;del++)
      {
         EnterBuffer[del]=0;
         EditBuffer[del]=0;
         ExitBuffer[del]=0;
         TPEnterBuffer[del]=0;
         SLEnterBuffer[del]=0;
         TPEditBuffer[del]=0;
         SLEditBuffer[del]=0;
         EmptyBuffer[del]=0;
      }         
     }
   else first=prev_calculated-1; //      

   for(i=first;i<rates_total && !IsStopped();i++)
     {
     
      if(i == rates_total-323)
         {
            out =  "";
            }
            
      int j = BarsCalculated(enter_ind_handle);
      CopyBuffer(enter_ind_handle,enter_ind_line,BarsCalculated(enter_ind_handle)-i,1,buffer_tmp);
      EnterBuffer[i]=buffer_tmp[0];       
      CopyBuffer(edit_ind_handle,edit_ind_line,BarsCalculated(edit_ind_handle)-i,1,buffer_tmp);
      EditBuffer[i]=buffer_tmp[0];  
      CopyBuffer(exit_ind_handle,exit_ind_line,BarsCalculated(exit_ind_handle)-i,1,buffer_tmp);
      ExitBuffer[i]=buffer_tmp[0];                    
      if(enter_tp_allow){
      CopyBuffer(enter_tpsl_ind_handle,enter_tp_ind_line,BarsCalculated(enter_tpsl_ind_handle)-i,1,buffer_tmp);
      TPEnterBuffer[i]=buffer_tmp[0];}
      if(enter_sl_allow){
      CopyBuffer(enter_tpsl_ind_handle,enter_sl_ind_line,BarsCalculated(enter_tpsl_ind_handle)-i,1,buffer_tmp);
      SLEnterBuffer[i]=buffer_tmp[0];}
      if(edit_tp_allow){   
      CopyBuffer(edit_tpsl_ind_handle,edit_tp_ind_line,BarsCalculated(edit_tpsl_ind_handle)-i,1,buffer_tmp);
      TPEditBuffer[i]=buffer_tmp[0];}
      if(edit_sl_allow){
      CopyBuffer(edit_tpsl_ind_handle,edit_sl_ind_line,BarsCalculated(edit_tpsl_ind_handle)-i,1,buffer_tmp);
      SLEditBuffer[i]=buffer_tmp[0];}      
      EmptyBuffer[i]=open[i];            
      
      vTradeAllow(i,time,open,high,low,close);
     
      EnterAllow = fEnterAllow(i);
      EditAllow  = fEditAllow(i);
      ExitAllow  = fExitAllow(i);
      
      TP_Enter_Allow = fTPSLAllow(i,TP_Enter_Allow,enter_tp_allow);
      SL_Enter_Allow = fTPSLAllow(i,SL_Enter_Allow,enter_sl_allow);
      TP_Edit_Allow  = fTPSLAllow(i,TP_Edit_Allow,edit_tp_allow);
      SL_Edit_Allow  = fTPSLAllow(i,SL_Edit_Allow,edit_sl_allow);    

      EnterSignal = YmovaEnter(i,time,open,high,low,close);
      EditSignal  = YmovaEdit(i,time,open,high,low,close);
      ExitSignal  = YmovaExit(i,time,open,high,low,close);  
      
      TP_Enter_Signal = YmovaEnterTP(i,time,open,high,low,close);
      SL_Enter_Signal = YmovaEnterSL(i,time,open,high,low,close);
      TP_Edit_Signal  = YmovaEditTP(i,time,open,high,low,close);
      SL_Edit_Signal  = YmovaEditSL(i,time,open,high,low,close);
      
      if(enter_tp_allow) TPEnterBuffer[i] = TP_Enter_Signal; else TPEnterBuffer[i] = 0;
      if(enter_sl_allow) SLEnterBuffer[i] = SL_Enter_Signal; else SLEnterBuffer[i] = 0;
      if(edit_tp_allow)  TPEditBuffer[i]  = TP_Edit_Signal;  else TPEditBuffer[i]  = 0;
      if(edit_sl_allow)  SLEditBuffer[i]  = SL_Edit_Signal;  else SLEditBuffer[i]  = 0;
      //      
      if(TPEditBuffer[i]>0&&TP_Edit_Signal>0) TPEnterBuffer[i] = TPEditBuffer[i];
      if(SLEditBuffer[i]>0&&SL_Edit_Signal>0) SLEnterBuffer[i] = SLEditBuffer[i];
      
      CheckEnterSignal(i,EnterSignal,TP_Enter_Signal,SL_Enter_Signal);
      CheckEditSignal(i,EditSignal,TP_Edit_Signal,SL_Edit_Signal);
      
      ExitSignal  = YmovaExitByTPSL(i,time,open,high,low,close); 
      
      TP_Enter_Allow = fTPSLAllow(i,TP_Enter_Allow,enter_tp_allow);
      SL_Enter_Allow = fTPSLAllow(i,SL_Enter_Allow,enter_sl_allow);
      TP_Edit_Allow  = fTPSLAllow(i,TP_Edit_Allow,edit_tp_allow);
      SL_Edit_Allow  = fTPSLAllow(i,SL_Edit_Allow,edit_sl_allow); 
      
      
     /*       
      switch(_Period)
      {
         case PERIOD_M1 : 
            {
               if(i>=2)
               {
               if(EnterBuffer[i-1]     >0 && EnterBuffer[i-2] ==0)   EnterBuffer[i-1]  = EnterBuffer[i-1];
               if(EditBuffer[i-1]      >0 && EditBuffer[i-2]  ==0)   EditBuffer[i-1]   = EditBuffer[i-1];               
               if(ExitBuffer[i-1]      >0 && ExitBuffer[i-2]  ==0)   ExitBuffer[i-1]   = ExitBuffer[i-1];               
               }              
               break;
            }
         default        : {break;}
      }  
      */    
     }

//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
//{ 
void Ind_Enter(int ind_num, string Sym, ENUM_TIMEFRAMES Per,int &Handle)
{
   switch(ind_num)
   {
      case 0  : Handle=iCustom(Sym,Per,"FB",period,fibolevel);break;
      default : Handle=iCustom(Sym,Per,"FB",period,fibolevel);break;
   }
}
void Ind_Edit(int ind_num, string Sym, ENUM_TIMEFRAMES Per,int &Handle)
{
   switch(ind_num)
   {
      case 0  : Handle=iCustom(Sym,Per,"FB",period,fibolevel);break;
      default : Handle=iCustom(Sym,Per,"FB",period,fibolevel);break;
   }
}

void Ind_Exit(int ind_num, string Sym, ENUM_TIMEFRAMES Per,int &Handle)
{
   switch(ind_num)
   {
      case 0  : Handle=iCustom(Sym,Per,"FB",period,fibolevel);break;
      default : Handle=iCustom(Sym,Per,"FB",period,fibolevel);break;
   }
}

void Ind_Enter_TPSL(int ind_num, string Sym, ENUM_TIMEFRAMES Per,int &Handle)
{
   switch(ind_num)
   {
      case 0  : Handle=iCustom(Sym,Per,"PP",InpPivotType,InpPivotPeriod);break;
      case 1  : Handle=iCustom(Sym,Per,"BB",InpBandsPeriod,InpBandsDeviations);break;
      default : Handle=iCustom(Sym,Per,"PP",InpPivotType,InpPivotPeriod);break;
   }
}

void Ind_Edit_TPSL(int ind_num, string Sym, ENUM_TIMEFRAMES Per,int &Handle)
{
   switch(ind_num)
   {
      case 0  : Handle=iCustom(Sym,Per,"PP",InpPivotType,InpPivotPeriod);break;
      case 1  : Handle=iCustom(Sym,Per,"BB",InpBandsPeriod,InpBandsDeviations);break;
      default : Handle=iCustom(Sym,Per,"PP",InpPivotType,InpPivotPeriod);break;
   }
}
//
double YmovaEnter(int pos,const datetime &TimeBuf[], const double &OpenBuf[],const double &HighBuf[],const double &LowBuf[], const double &CloseBuf[])
{
   double result = EnterSignal;
   switch(enter_y)
   {
   
      case 0  : //OpenBuf>=SignalBuf
         {
            if(EnterBuffer[pos]!=0&&EnterAllow)
            EnterBuffer[pos]=OpenBuf[pos];else EnterBuffer[pos]= 0;         
            break;
         }   
      case 1  : //OpenBuf>=SignalBuf
         {
            if(OpenBuf[pos]>= EnterBuffer[pos]&&OpenBuf[pos-1]<EnterBuffer[pos]&&EnterAllow)
            EnterBuffer[pos]=OpenBuf[pos];else EnterBuffer[pos]= 0;         
            break;
         }
      case 2  :
         {
            if(OpenBuf[pos]<= EnterBuffer[pos]&&OpenBuf[pos-1]>EnterBuffer[pos]&&EnterAllow)
            EnterBuffer[pos]=OpenBuf[pos];else EnterBuffer[pos]= 0;         
            break;
         }      
      default :
         {
            EnterBuffer[pos] = 0;
            break;
         } 
   }   
   if(EnterBuffer[pos]!=0) result = EnterBuffer[pos];  
   return(result);
}

//
double YmovaEdit(int pos,const datetime &TimeBuf[], const double &OpenBuf[],const double &HighBuf[],const double &LowBuf[], const double &CloseBuf[])
{
   double result = EditSignal;
   switch(edit_y)
   {
   
      case 0  : //OpenBuf>=SignalBuf
         {
            if(TradeAllow[1]==0&&TradeAllow[0]>0&&EnterSignal<OpenBuf[pos]&&EditAllow)
            {
               if(System_Order_Type == ORDER_TYPE_BUY) 
                    EditBuffer[pos] = HighBuf[pos]+100*_Point;
               else 
                    EditBuffer[pos] = LowBuf[pos]-100*_Point;               
            } 
            else    EditBuffer[pos] = 0;
            break;
         }   
      case 1  : //OpenBuf>=SignalBuf
         {
            if(TradeAllow[1]==0&&TradeAllow[0]>0&&EnterSignal>OpenBuf[pos]&&EditAllow) 
            {
               if(System_Order_Type == ORDER_TYPE_BUY) 
                    EditBuffer[pos] = HighBuf[pos]+100*_Point; 
               else 
                    EditBuffer[pos] = LowBuf[pos]-100*_Point;
            } 
            else EditBuffer[pos] = 0;        
            break;
         }
      default :
         {
            EditBuffer[pos] = 0; 
            break;
         } 
   }  
   if(EditBuffer[pos]!=0) result = EditBuffer[pos];  
   return(result);      
}

double YmovaExit(int pos,const datetime &TimeBuf[], const double &OpenBuf[],const double &HighBuf[],const double &LowBuf[], const double &CloseBuf[])
{
   double result = ExitSignal;
   switch(exit_y)
   {
   
      case 0  : //OpenBuf>=SignalBuf
         {
            if(TradeAllow[1]==0&&TradeAllow[0]>0&&EnterSignal>OpenBuf[pos]&&ExitAllow)
            {
               if(System_Order_Type == ORDER_TYPE_BUY) 
                    ExitBuffer[pos] = HighBuf[pos]+100*_Point;
               else 
                    ExitBuffer[pos] = LowBuf[pos]-100*_Point;               
            } 
            else    ExitBuffer[pos] = 0;
            break;
         }   
      case 1  : //OpenBuf>=SignalBuf
         {
            if(TradeAllow[1]==0&&TradeAllow[0]>0&&EnterSignal<OpenBuf[pos]&&ExitAllow) 
            {
               if(System_Order_Type == ORDER_TYPE_BUY) 
                    ExitBuffer[pos] = HighBuf[pos]+100*_Point; 
               else 
                    ExitBuffer[pos] = LowBuf[pos]-100*_Point;
            } 
            else ExitBuffer[pos] = 0;        
            break;
         }
      case 3  :
         {
            if(ExitBuffer[pos]!=0&&ExitAllow)
            ExitBuffer[pos]=OpenBuf[pos];else ExitBuffer[pos]= 0;         
            break;         
         }
      default :
         {
            ExitBuffer[pos] = 0; 
            break;
         } 
   }  
   result = ExitBuffer[pos];  
   return(result);    
}

double YmovaExitByTPSL(int pos,const datetime &TimeBuf[], const double &OpenBuf[],const double &HighBuf[],const double &LowBuf[], const double &CloseBuf[])
{
   double result = ExitSignal;
   switch(System_Order_Type)
   {
   
      case ORDER_TYPE_BUY  : 
         {
            if(OpenBuf[pos]>=TPEnterBuffer[pos]&&TPEnterBuffer[pos]>0&&ExitAllow) ExitBuffer[pos] = HighBuf[pos]+100*_Point;
            if(OpenBuf[pos]<=SLEnterBuffer[pos]&&SLEnterBuffer[pos]>0&&ExitAllow) ExitBuffer[pos] = LowBuf[pos]-100*_Point;
            break;
         }   
      case ORDER_TYPE_SELL  : 
         {
            if(OpenBuf[pos]<=TPEnterBuffer[pos]&&TPEnterBuffer[pos]>0&&ExitAllow) ExitBuffer[pos] = LowBuf[pos]-100*_Point;
            if(OpenBuf[pos]>=SLEnterBuffer[pos]&&SLEnterBuffer[pos]>0&&ExitAllow) ExitBuffer[pos] = HighBuf[pos]+100*_Point;
            break;
         } 
      default :
         {
            break;
         } 
   }  
   result = ExitBuffer[pos];  
   return(result);    
}

double YmovaEnterTP(int pos,const datetime &TimeBuf[], const double &OpenBuf[],const double &HighBuf[],const double &LowBuf[], const double &CloseBuf[])
{
   double result = TP_Enter_Signal;
   switch(enter_tpsl_y)
   {
   
      case 0  : //OpenBuf>=SignalBuf
         {
            if(TP_Enter_Allow&&enter_tp_allow&&EnterBuffer[pos]>0)
            {
               result = TPEnterBuffer[pos];
            } 
            if(!TP_Enter_Allow)    result = 0;
            break;
         }            
      default :
         {
            if(TP_Enter_Allow&&enter_tp_allow&&EnterBuffer[pos]>0)
            {
               result = TPEnterBuffer[pos];
            } 
            if(!TP_Enter_Allow)    result = 0;
            break;
         } 
   }  
   return(result);    
}

double YmovaEnterSL(int pos,const datetime &TimeBuf[], const double &OpenBuf[],const double &HighBuf[],const double &LowBuf[], const double &CloseBuf[])
{
   double result = SL_Enter_Signal;
   switch(enter_tpsl_y)
   {
   
      case 0  : //OpenBuf>=SignalBuf
         {
            if(SL_Enter_Allow&&enter_sl_allow&&EnterBuffer[pos]>0)
            {
               result = SLEnterBuffer[pos];
            } 
            if(!SL_Enter_Allow)    result = 0;
            break;
         }   
      default :
         {
            if(SL_Enter_Allow&&enter_sl_allow&&EnterBuffer[pos]>0)
            {
               result = SLEnterBuffer[pos];
            } 
            if(!SL_Enter_Allow)    result = 0;
            break;
         } 
   }  
   return(result);    
}

double YmovaEditTP(int pos,const datetime &TimeBuf[], const double &OpenBuf[],const double &HighBuf[],const double &LowBuf[], const double &CloseBuf[])
{
   double result = TP_Edit_Signal;
   switch(edit_tpsl_y)
   {
   
      case 0  : //OpenBuf>=SignalBuf
         {
            if(TP_Edit_Allow&&edit_tp_allow&&EditBuffer[pos]>0)
            {
               result = TPEditBuffer[pos];
            } 
            if(!TP_Edit_Allow)    result = 0;
            break;
         }   
      default :
         {
            if(TP_Edit_Allow&&edit_tp_allow&&EditBuffer[pos]>0)
            {
               result = TPEditBuffer[pos];
            } 
            if(!TP_Edit_Allow)    result = 0;
            break;
         } 
   }  
   
   return(result);    
}

double YmovaEditSL(int pos,const datetime &TimeBuf[], const double &OpenBuf[],const double &HighBuf[],const double &LowBuf[], const double &CloseBuf[])
{
   double result = SL_Edit_Signal;
   switch(edit_tpsl_y)
   {
   
      case 0  : //OpenBuf>=SignalBuf
         {
            if(SL_Edit_Allow&&edit_sl_allow&&EditBuffer[pos]>0)
            {
               result = EnterSignal;
            } 
            if(!SL_Edit_Allow)    result = 0;
            break;
         }     
      case 1  : //OpenBuf>=SignalBuf
         {
            if(SL_Edit_Allow&&edit_sl_allow&&EditBuffer[pos]>0)
            {
               result = SLEditBuffer[pos];
            } 
            if(!SL_Edit_Allow)    result = 0;
            break;
         }   
      default :
         {
            if(SL_Edit_Allow&&edit_sl_allow&&EditBuffer[pos]>0)
            {
               result = SLEditBuffer[pos];
            } 
            if(!SL_Edit_Allow)    result = 0;
            break;
         } 
   }  
   return(result);    
}

int CheakNewBar( )
{
	MqlRates		current_rates[ 1 ];

	ResetLastError( );
	if( CopyRates( Symbol( ), Period( ), 0, 1, current_rates ) != 1 )
	{
		Print( "  CopyRates,  = ", GetLastError( ));
		return( 0 );
	}

	if( current_rates[ 0 ].tick_volume > 1 )
	{
		return( 0 );
	}

	return( 1 );
}
void vTradeAllow(int pos,const datetime &TimeBuf[], const double &OpenBuf[],const double &HighBuf[],const double &LowBuf[], const double &CloseBuf[])
{
      MqlDateTime BeforTime,CurTime,NewTime;
      // StartBuffer
      TimeToStruct(TimeBuf[pos-1],BeforTime);
      TimeToStruct(TimeBuf[pos],CurTime);      
      //1- .     
      if(BeforTime.hour>=Start_Trade)   
         {
            NewTime = BeforTime;
            NewTime.hour = Start_Trade;
            NewTime.min = 0;
            NewTime.sec = 0;
            StartTimeBuffer[0] = StructToTime(NewTime);
         }
      if(BeforTime.hour>=Stop_Trade)    
         {
            NewTime = BeforTime;
            NewTime.hour = Stop_Trade;
            NewTime.min = 0;
            NewTime.sec = 0;
            StopTimeBuffer[0] = StructToTime(NewTime);
         }      
      if(CurTime.hour>=Start_Trade)   
         {
            NewTime = CurTime;
            NewTime.hour = Start_Trade;
            NewTime.min = 0;
            NewTime.sec = 0;
            StartTimeBuffer[1] = StructToTime(NewTime);
         }
      if(CurTime.hour>=Stop_Trade)    
         {
            NewTime = CurTime;
            NewTime.hour = Stop_Trade;
            NewTime.min = 0;
            NewTime.sec = 0;
            StopTimeBuffer[1] = StructToTime(NewTime);
         }
      //2- .     . 
      if(StartTimeBuffer[1]>=StopTimeBuffer[1]) TradeAllow[1] = OpenBuf[pos];   else TradeAllow[1] = 0;
      if(StartTimeBuffer[0]>=StopTimeBuffer[0]) TradeAllow[0] = OpenBuf[pos-1]; else TradeAllow[0] = 0;
}

bool fEnterAllow(int pos)
{
      bool result = EnterAllow;
      //     
      if(TradeAllow[1]>0&&TradeAllow[0]==0) {result = true;} 
      if(TradeAllow[1]==0&&TradeAllow[0]>0) {result = false;}
      //if(EnterBuffer[pos-1]>0) {result = false;}
      
      return(result);
}

bool fEditAllow(int pos)
{
      bool result = EditAllow;
      switch(System_Type)
      {
         case 0  : 
            {
               if(EnterBuffer[pos-1]>0) {result = true;} 
               if(EditBuffer[pos-1]>0) {result = false;} 
               if(ExitBuffer[pos-1]>0) {result = false;} 
               if(!edit_tp_allow&&!edit_sl_allow) {result = false;} 
               break;
            }
         case 1  : 
            {
               if(EnterBuffer[pos-1]>0) {result = true;} 
               if(ExitBuffer[pos-1]>0) {result = false;} 
               if(!edit_tp_allow&&!edit_sl_allow) {result = false;} 
               break;
            }
         case 2  : 
            {
               result = false;
               break;
            }            
         default : 
            {
               if(EnterBuffer[pos-1]>0) {result = true;} 
               if(EditBuffer[pos-1]>0) {result = false;} 
               if(ExitBuffer[pos-1]>0) {result = false;} 
               if(!edit_tp_allow&&!edit_sl_allow) {result = false;} 
               break;
            }
      }     
      return(result);
}

bool fExitAllow(int pos)
{
      bool result = ExitAllow;
      switch(System_Type)
      {
         case 0  : 
            {
               if(EnterBuffer[pos-1]>0) {result = true;} 
               if(ExitBuffer[pos-1]>0) {result = false;} 
               break;
            }
         case 1  : 
            {
               if(EnterBuffer[pos-1]>0) {result = true;} 
               if(ExitBuffer[pos-1]>0) {result = false;} 
               break;
            }
         default : 
            {
               if(EnterBuffer[pos-1]>0) {result = true;} 
               if(ExitBuffer[pos-1]>0) {result = false;} 
               break;
            }  
      }   
      return(result);
}

bool fTPSLAllow(int pos, bool &Allow, bool sysAllow)
{
      bool result = Allow;
      
      if(EnterBuffer[pos]>0&&sysAllow)  {result = true;} 
      if(ExitBuffer[pos]>0&&ExitAllow) {result = false;} 
 
      return(result);
}

void CheckEnterSignal(int pos, double &Signal, double &TP, double &SL)
{
   switch(System_Order_Type)
      {
         case ORDER_TYPE_BUY : 
            {
               if(TP<=Signal&&TP>0&&Signal>0) {Signal = 0; TP = 0; EnterBuffer[pos]=0;}
               if(SL>=Signal&&SL>0&&Signal>0) {Signal = 0; TP = 0; EnterBuffer[pos]=0;}
               break;
            }
         case ORDER_TYPE_SELL : 
            {
               if(TP>=Signal&&TP>0&&Signal>0) {Signal = 0; TP = 0; EnterBuffer[pos]=0;}
               if(SL<=Signal&&SL>0&&Signal>0) {Signal = 0; TP = 0; EnterBuffer[pos]=0;}
               break;
            }            
      }
}

void CheckEditSignal(int pos, double &Signal, double &TP, double &SL)
{
   switch(System_Order_Type)
      {
         case ORDER_TYPE_BUY : 
            {
               if(TP<=Signal&&TP>0&&Signal>0) {Signal = 0; TP = 0; EditBuffer[pos]=0;}
               if(SL>=Signal&&SL>0&&Signal>0) {Signal = 0; TP = 0; EditBuffer[pos]=0;}
               break;
            }
         case ORDER_TYPE_SELL : 
            {
               if(TP>=Signal&&TP>0&&Signal>0) {Signal = 0; TP = 0; EditBuffer[pos]=0;}
               if(SL<=Signal&&SL>0&&Signal>0) {Signal = 0; TP = 0; EditBuffer[pos]=0;}
               break;
            }            
      }
}